
#include <mzlib.h>

#define BALKKAR 8
#define VALI 10

extern signed char sini[];

static unsigned char balkkar[40],rata[256*2];

void balkke(unsigned char col)
{
    col;
    _asm
        ld      hl,#_balkkar
        ld      e,4(ix)
        ld      d,#0
        srl     e
        jr      c,2$

        add     hl,de ; even
        ld      (hl),#0x26
        inc     hl
        ld      (hl),#0x76
        inc     hl
        ld      a,(hl)
        and     #0xf
        or      #0x20
        ld      (hl),a

        jp      3$

2$:     add     hl,de ; odd
        ld      a,(hl)
        and     #0xf0
        or      #0x2
        ld      (hl),a
        inc     hl
        ld      (hl),#0x67
        inc     hl
        ld      (hl),#0x62

3$:
    _endasm;
}

void copyrow(void *dst,void *src)
{
    dst;src;
    _asm
    push    hl
    push    de

    ld      e,4(ix)
    ld      d,5(ix)
    ld      l,6(ix)
    ld      h,7(ix)

    push    hl
    ld      bc,#40
    ldir
    pop     hl
    push    hl
    ld      bc,#40
    ldir
    pop     hl
    ld      bc,#40
    ldir

    pop     de
    pop     hl
    _endasm;
}

void balkke2(unsigned char col)
{
    col;
    _asm
        ld      hl,#_balkkar
        ld      e,4(ix)
        ld      d,#0
        srl     e
        jr      c,2$

        add     hl,de ; even
        ld      (hl),#0x15
        inc     hl
        ld      (hl),#0x75
        inc     hl
        ld      a,(hl)
        and     #0xf
        or      #0x10
        ld      (hl),a

        jp      3$

2$:     add     hl,de ; odd
        ld      a,(hl)
        and     #0xf0
        or      #0x1
        ld      (hl),a
        inc     hl
        ld      (hl),#0x57
        inc     hl
        ld      (hl),#0x51

3$:
    _endasm;
}

void init_balkkar(void)
{
    int i;

    mem_set((char *)CHAR_TABLE,0x7b,40*25);
    mem_set(balkkar,0,40);

    for(i=0;i<256;i++)
        rata[i]= rata[i+256]= 38 + (sini[i*2&255]>>2) + (sini[255-i]>>4);
}

void run_balkkar(unsigned char num,unsigned char clearcol,unsigned char fase)
{
    unsigned char *rataptr,i,*petteri;

    rataptr=&rata[fase];

    // Advanced programming strategies pt.3
    petteri=(unsigned char *)COLOR_TABLE;
    for(i=0;i<BALKKAR;i++)
    {
        if(i<num)
        {
            if(i&1)
                balkke(*rataptr);
            else
                balkke2(*rataptr);
        }

        rataptr+=VALI;
        copyrow(petteri,balkkar);
        petteri+=120;
    }

    mem_cpy((char *)COLOR_TABLE+960,balkkar,40);
    mem_set_stack(balkkar,clearcol,40);
}
