
#include "mzlib.h"

static unsigned char *kbd1=(unsigned char *)0xe000,
                     *kbd2=(unsigned char *)0xe001;

char ispressed(unsigned char line,unsigned char bitti)
{
    char    c;

    c=0xf0|line;
    *kbd1=c;
    c=*kbd2 & bitti;

    if(c==0)
    	return(1);
    else
	    return(0);
}

static unsigned randomseed=0x83cd;

unsigned random(void)
{
	_asm
	push	de

	ld	hl,(_randomseed)
	ld	de,#0x83cd
	ld	a,r
	add	a,e
	ld	e,a
	add	hl,de
	rrc	h
	rr	l
	ld	(_randomseed),hl

	pop	de
	_endasm;

	return(randomseed);
}

void mem_set(void *dest,unsigned char c,unsigned len)
{
   	dest;c;len;
    	_asm
    	push    de
    	push    hl
    	push    bc

    	ld      l,4(ix) ; Parametrit
    	ld      h,5(ix)
    	ld	c,6(ix)
    	ld      e,7(ix)
    	ld      d,8(ix)
    	push    de

    	srl     d   ; DE/8
    	rr      e
    	srl     d
   	rr      e
    	srl     d
    	rr      e
    	ld      a,d
    	or      e
    	jp      z,2$

1$:
   	ld	(hl),c
	inc	hl
   	ld	(hl),c
	inc	hl
   	ld	(hl),c
	inc	hl
   	ld	(hl),c
	inc	hl
   	ld	(hl),c
	inc	hl
   	ld	(hl),c
	inc	hl
   	ld	(hl),c
	inc	hl
   	ld	(hl),c
	inc	hl

	dec     de
    	ld      a,d
    	or      e
    	jp      nz,1$

2$:
    	pop     de      ; The modulo part
    	ld      a,e
    	and     #7
    	jp      z,4$

	ld	b,a
3$:
    	ld      (hl),c
	inc	hl
    	djnz	3$

4$:
    	pop     bc
    	pop     hl
    	pop     de
    	_endasm;
}

void mem_set_stack(void *dest,unsigned char c,unsigned len)
{
   	dest;c;len;
    	_asm
    	push    de
    	push    hl
    	push    bc

    	ld      l,4(ix) ; Parametrit
    	ld      h,5(ix)
    	ld	c,6(ix)
	ld	b,c
    	ld      e,7(ix)
    	ld      d,8(ix)
	push	hl
    	push    de
	add	hl,de

    	srl     d   ; DE/16
    	rr      e
    	srl     d
   	rr      e
    	srl     d
    	rr      e
    	srl     d
    	rr      e
    	ld      a,d
    	or      e
    	jp      z,2$
	
	ld	ix,#0
	add	ix,sp
	ld	sp,hl

1$:	
	push	bc
	push	bc
	push	bc
	push	bc
	push	bc
	push	bc
	push	bc
	push	bc

	dec     de
    	ld      a,d
    	or      e
    	jp      nz,1$

	ld	sp,ix

2$:
	pop	de
    	pop     hl      ; The modulo part
    	ld      a,e
    	and     #15
    	jp      z,4$

	ld	b,a
3$:
    	ld      (hl),c
	inc	hl
    	djnz	3$

4$:
    	pop     bc
    	pop     hl
    	pop     de
    	_endasm;
}

void mem_cpy(void *dest,void *src,unsigned len)
{
	dest;src;len;
    	_asm
    	push    de
    	push    hl

    	ld      e,4(ix) ; Parametrit
    	ld      d,5(ix)
    	ld	    l,6(ix)
    	ld	    h,7(ix)
    	ld      c,8(ix)
    	ld      b,9(ix)

        ld	    a,c
        or	    b
        jp	    z,$1
        ldir

$1:
    	pop     hl
    	pop     de
    	_endasm;
}

void ascii_string(char *str)
{
    char *s=str;
    while(*s)
    {
        *s=ascii_char(*s);
        s++;
    }
}

static char konvattu;

char ascii_char(char c)
{
    c;
    _asm
    ld      a,4(ix)
    call    0xbb9
    ld      (_konvattu),a
    _endasm;

    return konvattu;
}

void poke(unsigned addr,unsigned char c)
{
    *(unsigned char *)addr=c;
}

unsigned char peek(unsigned addr)
{
    return *(unsigned char *)addr;
}

void leftcol(unsigned char col)
{
    col;
    _asm

    ld      a,4(ix)

    ld      (0xd800+0),a
    ld      (0xd800+40),a
    ld      (0xd800+80),a
    ld      (0xd800+120),a

    ld      (0xd800+160),a
    ld      (0xd800+200),a
    ld      (0xd800+240),a
    ld      (0xd800+280),a

    ld      (0xd800+320),a
    ld      (0xd800+360),a
    ld      (0xd800+400),a
    ld      (0xd800+440),a

    ld      (0xd800+480),a
    ld      (0xd800+520),a
    ld      (0xd800+560),a
    ld      (0xd800+600),a

    ld      (0xd800+640),a
    ld      (0xd800+680),a
    ld      (0xd800+720),a
    ld      (0xd800+760),a

    ld      (0xd800+800),a
    ld      (0xd800+840),a
    ld      (0xd800+880),a
    ld      (0xd800+920),a

    ld      (0xd800+960),a

    _endasm;
}
