
#ifndef MZLIB_H
#define MZLIB_H

#define BLACK       0
#define BLUE        1
#define RED         2
#define MAGENTA     3
#define GREEN       4
#define CYAN        5
#define YELLOW      6
#define WHITE       7

#define BG_BLACK       0x00
#define BG_BLUE        0x10
#define BG_RED         0x20
#define BG_MAGENTA     0x30
#define BG_GREEN       0x40
#define BG_CYAN        0x50
#define BG_YELLOW      0x60
#define BG_WHITE       0x70

#define CHAR_TABLE  0xd000
#define COLOR_TABLE 0xd800

/* Use these as ispressed() parameters */

#define K_CR	0,1
#define K_COLON	0,2
#define K_SEMICOLON	0,4
#define K_ALPHA	0,16
#define K_ARROWDOWN	0,32
#define K_GRAPH	0,64
#define K_UNDER	0,128

#define K_PARENCLOSE	1,8
#define K_PARENOPEN 1,16
#define K_AT 1,32
#define K_Z 1,64
#define K_Y 1,128

#define K_X	2,1
#define K_W	2,2
#define K_V	2,4
#define K_U 2,8
#define K_T	2,16
#define K_S	2,32
#define K_R	2,64
#define K_Q	2,128

#define K_P	3,1
#define K_O	3,2
#define K_N	3,4
#define K_M	3,8
#define K_L	3,16
#define K_K	3,32
#define K_J	3,64
#define K_I	3,128

#define K_H	4,1
#define K_G	4,2
#define K_F	4,4
#define K_E	4,8
#define K_D	4,16
#define K_C	4,32
#define K_B	4,64
#define K_A	4,128

#define K_8	5,1
#define K_7	5,2
#define K_6	5,4
#define K_5	5,8
#define K_4	5,16
#define K_3	5,32
#define K_2	5,64
#define K_1	5,128

#define K_PERIOD	6,1
#define K_COMMA	6,2
#define K_9	6,4
#define K_0	6,8
#define K_SPACE	6,16
#define K_MINUS	6,32
#define K_ARROWUP	6,64
#define K_BACKSLASH	6,128

#define K_SLASH	7,1
#define K_QUESTION	7,2
#define K_LEFT	7,4
#define K_RIGHT	7,8
#define K_DOWN	7,16
#define K_UP	7,32
#define K_DEL	7,64
#define K_INST	7,128

#define K_SHIFT 8,1
#define K_CTRL	8,64
#define K_BREAK	8,128

#define K_F5	9,8
#define K_F4	9,16
#define K_F3	9,32
#define K_F2	9,64
#define K_F1	9,128

#define waitVB() _asm call 0x0da6 _endasm
#define download() _asm jp 0xcf00 _endasm // Jump to transfer software

                                    /* Check if some key is pressed */
char ispressed(unsigned char line,unsigned char bitti);
#define space() ispressed(K_SPACE)  /* Special macro for space */

unsigned random(void);

void ascii_string(char *str);
char ascii_char(char c);

void poke(unsigned addr,unsigned char c);
unsigned char peek(unsigned addr);

void leftcol(unsigned char col); // Color column 0 for "raster time meter"

void mem_set(void *dest,unsigned char c,unsigned len);
void mem_set_stack(void *dest,unsigned char c,unsigned len); // Not VBI safe
void mem_cpy(void *dest,void *src,unsigned len);

#endif
