
#include <mzlib.h>
#include "pano_osa.h"

extern unsigned distort[];
extern unsigned char kekkonen[];

static unsigned char *iso_klumppi;

void look_up(int off,void *texture,void *dest)
{
    off;texture;dest;
    _asm
    push    hl
    push    de

    ld      c,4(ix)
    ld      b,5(ix)
    ld      l,6(ix)
    ld      h,7(ix)
    add     hl,bc
    ld      b,h
    ld      c,l
    ld      e,8(ix)
    ld      d,9(ix)

    ld      hl,#3$
    push    hl
    ld      hl,(_iso_klumppi)
    push    hl
    ret          ; "call"

3$:
    pop     de
    pop     hl
    _endasm;
}

// "Grayscale" in charset 2
static unsigned char chrs[]={0x00,0x85,0x82,0x86,0x87,0x8a,0x3e,0x89};

static unsigned char bgcols[40];

void init_pano(void *blokki)
{
    unsigned n,off;

    iso_klumppi=blokki;

    // Generate code for lookup
    for(n=0;n<40*25;n++)
    {
        *iso_klumppi++ = 0x21;            // ld hl,nnnn
        off=distort[n]+n; // Compensate for ldi
        *iso_klumppi++ = off&0xff;
        *iso_klumppi++ = off>>8;

        *iso_klumppi++ = 0x9;             // add hl,bc
        *iso_klumppi++ = 0xed;            // ldi
        *iso_klumppi++ = 0xa0;
    }
    *iso_klumppi=0xc9; // ret

    iso_klumppi=blokki;

    for(n=0;n<40;n++)
        bgcols[n]=0x80+0x20;

    mem_set((char *)COLOR_TABLE,0x80+0x20,40*25);

    for(n=0;n<128*32;n++)
        kekkonen[n]=chrs[kekkonen[n]>>5];
}

static void kolumni(unsigned char column,unsigned char c)
{
    column; c;
    _asm
    push    hl

    ld      l,4(ix)
    ld      h,#0
    ld      bc,#0xd800
    add     hl,bc
    ld      a,5(ix)
    ld      bc,#40

    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc

    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc

    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc

    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc
    ld      (hl),a
    add     hl,bc

    pop     hl
    _endasm;
}

void bgcolumns(unsigned char *upd)
{
    unsigned char c,n;

    for(n=0;n<40;n++)
    {
        c=*upd;
        if(c!=bgcols[n])
        {
            bgcols[n]=c;
            kolumni(n,c);
        }
        upd++;
    }
}

void run_pano(unsigned char phase)
{
    look_up(phase&63,kekkonen,(void *)CHAR_TABLE);
}
