
#include <mzlib.h>

extern unsigned distang[];

static unsigned dirty[256],*dirtyptr,dirtyi;

static unsigned char scr[1000];

void drawasm(unsigned char dist,unsigned char ang,char op)
{
    dist;ang;op;
    _asm
    push    hl
    push    de
    push    iy
    ld      iy,#0
    add     iy,sp

    ld      h,4(ix)
    ld      a,5(ix)
    and     #0xfe
    ld      l,a
    ld      de,#_distang
    add     hl,de
    ld      sp,hl
    pop     de
    pop     hl
    ld      sp,iy

    sbc     hl,de
    jr      z,10$

    dec     hl
    srl     h
    rr      l
    ld      a,l
    ld      (_dirtyi),a

    ex      de,hl
    ld      e,(hl)
    inc     hl
    ld      c,(hl)
    inc     hl
    ld      b,(hl)
    inc     hl

    ld      a,6(ix)
    or      a
    jp      nz,2$

1$:
    push    hl
    ld      hl,(_dirtyptr)
    ld      (hl),c
    inc     hl
    ld      (hl),b
    inc     hl
    ld      (_dirtyptr),hl
    ld      hl,#_scr
    add     hl,bc

    ld      a,e
    or      (hl)
    ld      (hl),a

    pop     hl
    ld      e,(hl)
    inc     hl
    ld      a,(hl)
    inc     hl
    push    hl
    ld      h,#0
    ld      l,a
    add     hl,bc
    ld      b,h
    ld      c,l
    pop     hl

    ld      a,(_dirtyi)
    dec     a
    ld      (_dirtyi),a
    jp      nz,1$

    jp      10$

2$:
    push    hl
    ld      hl,(_dirtyptr)
    ld      (hl),c
    inc     hl
    ld      (hl),b
    inc     hl
    ld      (_dirtyptr),hl
    ld      hl,#_scr
    add     hl,bc

    ld      a,e
    xor     #15
    and     (hl)
    ld      (hl),a

    pop     hl
    ld      e,(hl)
    inc     hl
    ld      a,(hl)
    inc     hl
    push    hl
    ld      h,#0
    ld      l,a
    add     hl,bc
    ld      b,h
    ld      c,l
    pop     hl

    ld      a,(_dirtyi)
    dec     a
    ld      (_dirtyi),a
    jp      nz,2$

10$:
    pop     iy
    pop     de
    pop     hl
    _endasm;
}

void refresh(void)
{
    _asm
    push    hl
    push    de
    ld      iy,#0
    add     iy,sp

    ld      hl,#_dirty
    ld      sp,hl
    ld      bc,#_scr
    ld      a,(_dirtyi)

1$:
    pop     hl
    push    hl
    ld      de,#0xd000
    add     hl,de
    ex      de,hl
    pop     hl
    add     hl,bc
    ldi
    inc     bc

    dec     a
    jp      nz,1$

    ld      sp,iy
    pop     de
    pop     hl
    _endasm;
}

void init_ympyraz(void)
{
    unsigned n;
    unsigned char x,y,c;

    mem_set(scr,240,40*25);

    n=COLOR_TABLE;
    for(y=0;y<25;y++)
    {
        if(random()&1)
            c=(MAGENTA<<4)+YELLOW;
        else
            c=(MAGENTA<<4)+WHITE;
        for(x=0;x<40;x++,n++)
            if(((x>>2)&1) ^ ((y>>2)&1))
            {
                if(random()&1)
                    poke(n,c);
                else
                    poke(n,c);
            }
            else
                poke(n,(RED<<4)+BLACK);
    }

    mem_set((char *)CHAR_TABLE,240,1000);

    dirtyi=0;
}

void run_ympyraz(unsigned char ang,unsigned char amount)
{
    if(dirtyi!=0)
         refresh();

    dirtyptr=dirty;

    if(amount>0)
    {
        drawasm(0,ang,0);
        drawasm(0,ang+64,1);
    }

    if(amount>1)
    {
        drawasm(0,ang+128,0);
        drawasm(0,ang+192,1);
    }

    if(amount>2)
    {
        drawasm(1,-ang,0);
        drawasm(1,-ang+128,1);
    }

    if(amount>3)
    {
        drawasm(2,ang,0);
        drawasm(2,ang+64,1);
    }

    if(amount>4)
    {
        drawasm(2,ang+128,0);
        drawasm(2,ang+192,1);
    }

    if(amount>5)
    {
        drawasm(3,-ang,0);
        drawasm(3,-ang+128,1);
    }

    dirtyi=((unsigned)dirtyptr-(unsigned)dirty)>>1;
}
